"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = withWrapper;

var _react = _interopRequireDefault(require("react"));

var _Provider = require("../core/Provider");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function withWrapper(Wrapper) {
  return function WrappedWrapper(_ref) {
    var children = _ref.children,
        history = _ref.history,
        match = _ref.match,
        location = _ref.location;
    var totalPages = children.length;
    var index = parseInt(match.params.index);
    var lastRouterRef = useRef({
      history: history,
      match: match,
      location: location
    });

    var _useTransitions = (0, _Provider.useTransitions)(),
        transition = _useTransitions.transition,
        definedTransitions = _useTransitions.transitions;

    var definedTransition = definedTransitions[transition];
    var transitions = useTransition({
      match: match,
      location: location
    }, function (_ref2) {
      var location = _ref2.location;
      return location.pathname;
    }, typeof definedTransition === 'function' ? definedTransition(lastRouterRef.current, {
      history: history,
      match: match,
      location: location
    }) : definedTransition);
    lastRouterRef.current = {
      history: history,
      match: match,
      location: location
    };

    function next() {
      if (index < children.length) history.push("/".concat(index + 1));
    }

    function back() {
      // history.goBack()
      if (index > 1) history.push("/".concat(index - 1));
    }

    return _react["default"].createElement(Wrapper, null);
  };
}