"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactRouterDom = require("react-router-dom");

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _reactSpring = require("react-spring");

var _ChevronLeft = _interopRequireDefault(require("@material-ui/icons/ChevronLeft"));

var _ChevronRight = _interopRequireDefault(require("@material-ui/icons/ChevronRight"));

var _Provider = require("../core/Provider");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _templateObject4() {
  var data = _taggedTemplateLiteral(["\n  display: flex;\n  height: 60px;\n  width: 60px;\n  border-radius: 30px;\n  background: rgba(200, 200, 200, 0.3);\n  align-items: center;\n  justify-content: center;\n  cursor: pointer;\n  opacity: 0.3;\n  transition: opacity 0.3s;\n\n  &:hover {\n    opacity: 1;\n  }\n\n  & + & {\n    margin-left: 20px;\n  }\n"]);

  _templateObject4 = function _templateObject4() {
    return data;
  };

  return data;
}

function _templateObject3() {
  var data = _taggedTemplateLiteral(["\n  position: absolute;\n  left: 0;\n  right: 0;\n  top: 0;\n  bottom: 0;\n  overflow: auto;\n"]);

  _templateObject3 = function _templateObject3() {
    return data;
  };

  return data;
}

function _templateObject2() {
  var data = _taggedTemplateLiteral(["\n  position: fixed;\n  right: 40px;\n  bottom: 40px;\n  display: flex;\n"]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = _taggedTemplateLiteral(["\n  height: 100%;\n  width: 100%;\n  overflow: hidden;\n  position: relative;\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var Root = _styledComponents["default"].div(_templateObject());

var Actions = _styledComponents["default"].div(_templateObject2());

var AnimatedDiv = (0, _styledComponents["default"])(_reactSpring.animated.div)(_templateObject3());

var ActionButton = _styledComponents["default"].a(_templateObject4());

function Wrapper(_ref) {
  var children = _ref.children,
      history = _ref.history,
      match = _ref.match,
      location = _ref.location;
  var index = parseInt(match.params.index);
  var lastRouterRef = (0, _react.useRef)({
    history: history,
    match: match,
    location: location
  });

  var _useTransitions = (0, _Provider.useTransitions)(),
      transition = _useTransitions.transition,
      definedTransitions = _useTransitions.transitions;

  var definedTransition = definedTransitions[transition]; // const transitions = useTransition(
  //   { match, location },
  //   ({ location }) => location.pathname,
  //   typeof definedTransition === 'function'
  //     ? definedTransition(lastRouterRef.current, { history, match, location })
  //     : definedTransition,
  // )

  var transitions = (0, _reactSpring.useTransition)( // Children.map(children, child => ({ test: index, ...child.props })),
  children, function (_ref2) {
    var props = _ref2.props;
    return props.index;
  }, {
    from: {
      transform: "translate3d(100%, 0, 0)"
    },
    enter: function enter(_ref3) {
      var props = _ref3.props;
      return {
        transform: "translate3d(".concat((props.index - index) * 100, "%, 0, 0)")
      };
    },
    leave: {
      transform: "translate3d(500%, 0, 0)"
    }
  });
  lastRouterRef.current = {
    history: history,
    match: match,
    location: location
  };

  function next() {
    if (index < children.length) history.push("/".concat(index + 1));
  }

  function back() {
    // history.goBack()
    if (index > 1) history.push("/".concat(index - 1));
  }

  (0, _react.useEffect)(function () {
    var listener = function listener(e) {
      var code = e.keyCode;

      if (code === 37 || code === 38) {
        back();
      }

      if (code === 39 || code === 40) {
        next();
      }
    };

    window.addEventListener('keydown', listener);
    return function () {
      return window.removeEventListener('keydown', listener);
    };
  }, [next, back]);
  return _react["default"].createElement(Root, {
    className: "markdown-body"
  }, transitions.map(function (_ref4) {
    var item = _ref4.item,
        props = _ref4.props,
        key = _ref4.key;
    return _react["default"].createElement(AnimatedDiv, {
      key: key,
      style: props
    }, item);
  }), _react["default"].createElement(Actions, null, index > 1 ? _react["default"].createElement(ActionButton, {
    onClick: back
  }, _react["default"].createElement(_ChevronLeft["default"], {
    style: {
      fontSize: 32
    }
  })) : null, index < children.length ? _react["default"].createElement(ActionButton, {
    onClick: next
  }, _react["default"].createElement(_ChevronRight["default"], {
    style: {
      fontSize: 32
    }
  })) : null));
}

var _default = (0, _reactRouterDom.withRouter)(Wrapper);

exports["default"] = _default;