"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = Provider;

var _react = _interopRequireDefault(require("react"));

var _react2 = require("@mdx-js/react");

var _styledComponents = require("styled-components");

var _config = _interopRequireDefault(require("config"));

var _index = _interopRequireDefault(require("../components/index"));

var _theme = _interopRequireDefault(require("./theme"));

var _transitions = _interopRequireDefault(require("./transitions"));

var _contexts = require("./contexts");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

// const transitionContext = createContext({})
// const themeContext = createContext({})
var TransitionProvider = _contexts.transitionContext.Provider; // const ThemeProvider = themeContext.Provider

var customComponents = _config["default"].components || {};
var customTransitions = _config["default"].transitions || {};
var transition = _config["default"].transition || 'slide';

if (typeof customComponents === 'function') {
  customComponents = customComponents(_index["default"]);
}

function Provider(_ref) {
  var children = _ref.children;
  return _react["default"].createElement(_react2.MDXProvider, {
    components: _objectSpread({}, _index["default"], customComponents)
  }, _react["default"].createElement(TransitionProvider, {
    value: {
      transition: transition,
      transitions: _objectSpread({}, _transitions["default"], customTransitions)
    }
  }, _react["default"].createElement(_styledComponents.ThemeProvider, {
    theme: _theme["default"]
  }, children)));
} // export function useTheme() {
//   return useContext(themeContext)
// }
// export function useTransitions() {
//   return useContext(transitionContext)
// }