"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = Router;
exports.useRouter = useRouter;

var _react = _interopRequireWildcard(require("react"));

var _history = require("history");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var history = (0, _history.createBrowserHistory)();
var historyContext = (0, _react.createContext)({});
var recents = [];
var urlReg = /\/([1-9][0-9]*)/;

function getIndex(url) {
  var match = urlReg.exec(url);

  if (match) {
    return parseInt(match[1]);
  }

  return 0;
}

function Router(_ref) {
  var children = _ref.children;

  var _useState = (0, _react.useState)(history.location),
      _useState2 = _slicedToArray(_useState, 2),
      location = _useState2[0],
      setLocation = _useState2[1];

  var _useState3 = (0, _react.useState)(getIndex(history.location.pathname)),
      _useState4 = _slicedToArray(_useState3, 2),
      index = _useState4[0],
      setIndex = _useState4[1];

  var next = (0, _react.useCallback)(function () {
    history.push("/".concat(index + 1)); // recents.push(index)
  }, [index]);
  var back = (0, _react.useCallback)(function () {
    // if (recents[recents.length - 1] - 1 === recents[recents.length - 2]) {
    //   history.goBack()
    //   // recents.splice(-1, 1)
    //   recents.pop()
    // } else {
    //   const index = recents.pop()
    //   recents = [index - 1]
    //   history.push(index)
    // }
    history.goBack();
  }, []);
  var context = (0, _react.useMemo)(function () {
    return {
      location: location,
      history: history,
      next: next,
      back: back,
      index: index
    };
  }, [location, next, back, index]);
  (0, _react.useEffect)(function () {
    var unListen = history.listen(function (location, action) {
      var index = getIndex(location.pathname);

      if (index === 0) {
        history.replace('/1');
        return;
      }

      setLocation(location);
      setIndex(index);
    });
    return unListen;
  }, []); // redirect at beginning

  (0, _react.useEffect)(function () {
    var index = getIndex(location.pathname);

    if (index === 0) {
      history.replace('/1');
      return;
    }
  }, []);
  return _react["default"].createElement(historyContext.Provider, {
    value: context
  }, children);
}

function useRouter() {
  return (0, _react.useContext)(historyContext);
}